Subject: Re: [PATCH ipsec,v3] net: xfrm_policy: fix device unregistration hang

From: Eyal Birger <[email-masked]>
Date: Tue, 13 Feb 2018 20:23:14 +0200

Hi Xin Long,

On Tue, 13 Feb 2018 23:18:14 +0800
Xin Long <[email-masked]> wrote:

> On Tue, Feb 13, 2018 at 6:54 PM, Eyal Birger <[email-masked]>
> wrote:
> > In setups like the following:
> >
> >        Host A          --        Host B
> > tun0 -- ipsec -- eth0  --  eth0 -- ipsec -- tun0
> >
> > where tun0 are tunnel devices using dst_cache (ipip, ipip6, etc...).
> >
> > Unregistration of an underlying eth0 device leads to the following
> > log messages:
> >
> > unregister_netdevice: waiting for eth0 to become free. Usage count
> > = 2
> >
> > This is since xfrm dsts device references are not released upon
> > device unregistration when the xfrm dst is cached in a dst_cache.
> >
> > This issue was first introduced in commit 52df157f17e5
> > ("xfrm: take refcnt of dst when creating struct xfrm_dst bundle")
> > as part of an effort to remove routing garbage collection.
> >
> > Several approaches for fixing this were discussed in [1]; this
> > commit keeps track of allocated xdsts and releases their device
> > references on a netdev unregister/down events.
> >
> > Signed-off-by: Eyal Birger <[email-masked]>
> > Fixes: 52df157f17e5 ("xfrm: take refcnt of dst when creating struct
> > xfrm_dst bundle")  
> I had another fix [1] for this issue in my local tree.
> That reuses uncached_list to track xdsts, and fewer job to do for
> this. As naturally uncached_list is already the list that is supposed
> to do this job. We don't have to introduce a new list and members.
> 
> [1] https://paste.fedoraproject.org/paste/X8FQzEXjGXQBTKAVLnDn4w

I have tested your patch and it resolves the issue described.
I like not having to introduce a new list and lock.

Small note: I think you need to increase net->ipv6.rt6_stats->fib_rt_uncache
when adding to the IPv6 uncached list from the xfrm code.

> 
> Not sure if it makes more sense for xfrm?

I wasn't sure whether xfrm may use the uncached list.
But it looks correct to me.

Eyal.